'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var __chunk_1 = require('./chunk-f34490ab.js');
var __chunk_2 = require('./chunk-c6f22cfe.js');

var _templateObject = __chunk_2.taggedTemplateLiteral(['\n  &::-webkit-scrollbar-track {\n    border-radius: 3px;\n    background-color: ', ';\n  }\n\n  &::-webkit-scrollbar {\n    width: 6px;\n    background-color: #fff;\n  }\n\n  &::-webkit-scrollbar-thumb {\n    border-radius: 3px;\n    background-color: ', ';\n  }\n'], ['\n  &::-webkit-scrollbar-track {\n    border-radius: 3px;\n    background-color: ', ';\n  }\n\n  &::-webkit-scrollbar {\n    width: 6px;\n    background-color: #fff;\n  }\n\n  &::-webkit-scrollbar-thumb {\n    border-radius: 3px;\n    background-color: ', ';\n  }\n']),
    _templateObject2 = __chunk_2.taggedTemplateLiteral(['\n  &,\n  * {\n    font-family: \'Open Sans\', Arial, Helvetica, sans-serif;\n    box-sizing: border-box;\n    text-decoration: none;\n  }\n'], ['\n  &,\n  * {\n    font-family: \'Open Sans\', Arial, Helvetica, sans-serif;\n    box-sizing: border-box;\n    text-decoration: none;\n  }\n']);

var flexPosition = function flexPosition(_ref) {
  var _ref$align = _ref.align,
      align = _ref$align === undefined ? '' : _ref$align,
      _ref$justify = _ref.justify,
      justify = _ref$justify === undefined ? '' : _ref$justify,
      _ref$direction = _ref.direction,
      direction = _ref$direction === undefined ? '' : _ref$direction;
  return '\n  display: flex;\n  ' + (align && 'align-items: ' + align + ';') + '\n  ' + (justify && 'justify-content: ' + justify + ';') + '\n  ' + (direction && 'flex-direction: ' + direction + ';') + '\n';
};

var fontStyle = function fontStyle(color, fontSize, fontWeight) {
  return '\n  ' + (color && 'color: ' + color + ';') + '\n  ' + (fontSize && 'font-size: ' + fontSize + ';') + '\n  ' + (fontWeight && 'font-weight: ' + fontWeight + ';') + '\n';
};

var customScrollbar = function customScrollbar() {
  return styled.css(_templateObject, __chunk_1.theme.colors.GRAY_LIGHT, __chunk_1.theme.colors.GRAY_LIGHT_2);
};

var globalStyle = function globalStyle() {
  return styled.css(_templateObject2);
};

var getColSize = function getColSize() {
  var colSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

  var col = colSize < 0 ? 1 : colSize;
  col = colSize > 12 ? 12 : colSize;
  var spacing = colSize === 1 ? __chunk_1.theme.grid.COL_SPACING : __chunk_1.theme.grid.COL_SPACING * (colSize - 1);
  return col * __chunk_1.theme.grid.COL_SIZE + spacing + 'px';
};

var mixins = /*#__PURE__*/Object.freeze({
  flexPosition: flexPosition,
  fontStyle: fontStyle,
  customScrollbar: customScrollbar,
  globalStyle: globalStyle,
  getColSize: getColSize
});

exports.flexPosition = flexPosition;
exports.fontStyle = fontStyle;
exports.customScrollbar = customScrollbar;
exports.globalStyle = globalStyle;
exports.getColSize = getColSize;
exports.mixins = mixins;
//# sourceMappingURL=chunk-29a2e288.js.map
