'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var reactRouterDom = require('react-router-dom');
var __chunk_3 = require('./chunk-29a2e288.js');
var __chunk_1 = require('./chunk-f34490ab.js');
var __chunk_2 = require('./chunk-c6f22cfe.js');

var _templateObject = __chunk_2.taggedTemplateLiteral(['\n  &:hover,\n  &:active,\n  &:focus,\n  &:visited {\n    text-decoration: none;\n  }\n  box-sizing: border-box;\n'], ['\n  &:hover,\n  &:active,\n  &:focus,\n  &:visited {\n    text-decoration: none;\n  }\n  box-sizing: border-box;\n']),
    _templateObject2 = __chunk_2.taggedTemplateLiteral(['\n  ', '\n  ', '\n  text-align: center;\n  padding: 5px 25px;\n  width: ', ';\n  height: ', ';\n  text-decoration: none;\n  ', '\n  &.active {\n    border-bottom: 4px solid\n      ', ';\n    padding-bottom: 1px;\n    color: ', ';\n    ', '\n  }\n  &:hover {\n    text-decoration: none;\n    color: ', ';\n    ', '\n  }\n  &:focus {\n    color: ', ';\n  }\n  ', '\n'], ['\n  ', '\n  ', '\n  text-align: center;\n  padding: 5px 25px;\n  width: ', ';\n  height: ', ';\n  text-decoration: none;\n  ', '\n  &.active {\n    border-bottom: 4px solid\n      ', ';\n    padding-bottom: 1px;\n    color: ', ';\n    ', '\n  }\n  &:hover {\n    text-decoration: none;\n    color: ', ';\n    ', '\n  }\n  &:focus {\n    color: ', ';\n  }\n  ', '\n']),
    _templateObject3 = __chunk_2.taggedTemplateLiteral(['\n  ', '\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n  ', '\n']),
    _templateObject4 = __chunk_2.taggedTemplateLiteral(['\n  ', '\n  background-color: transparent;\n  border: none;\n  cursor: pointer;\n  ', '\n'], ['\n  ', '\n  background-color: transparent;\n  border: none;\n  cursor: pointer;\n  ', '\n']),
    _templateObject5 = __chunk_2.taggedTemplateLiteral(['\n  ', ', ', ' {\n    border-bottom: 1px solid ', ';\n    &.active {\n      border-bottom: 4px solid ', ';\n      padding-bottom: 2px;\n    }\n  }\n'], ['\n  ', ', ', ' {\n    border-bottom: 1px solid ', ';\n    &.active {\n      border-bottom: 4px solid ', ';\n      padding-bottom: 2px;\n    }\n  }\n']);

var removeLinkEffects = styled.css(_templateObject);

var tabStyle = styled.css(_templateObject2, __chunk_3.fontStyle(__chunk_1.theme.colors.GRAY_MEDIUM_3, __chunk_1.theme.fontSizes.SIZE_7, __chunk_1.theme.fontWeights.SEMIBOLD), __chunk_3.flexPosition({ align: 'center', justify: 'center' }), function (_ref) {
  var width = _ref.width;
  return width || 'auto';
}, function (_ref2) {
  var height = _ref2.height;
  return height || '64px';
}, function (_ref3) {
  var nooutline = _ref3.nooutline;
  return nooutline ? 'outline: none;' : {};
}, function (_ref4) {
  var activebordercolor = _ref4.activebordercolor;
  return activebordercolor || __chunk_1.theme.colors.MAIN_COLOR;
}, __chunk_1.theme.colors.GRAY_DARKER, function (_ref5) {
  var activestyle = _ref5.activestyle;
  return activestyle;
}, function (_ref6) {
  var hovercolor = _ref6.hovercolor;
  return hovercolor || __chunk_1.theme.colors.GRAY_DARKER;
}, function (_ref7) {
  var hoverstyle = _ref7.hoverstyle;
  return hoverstyle;
}, function (_ref8) {
  var hovercolor = _ref8.hovercolor;
  return hovercolor || __chunk_1.theme.colors.GRAY_DARKER;
}, function (_ref9) {
  var customstyles = _ref9.customstyles;
  return customstyles;
});

var CustomNavLink = styled__default(reactRouterDom.NavLink)(_templateObject3, removeLinkEffects, tabStyle, function (_ref10) {
  var customStyles = _ref10.customStyles;
  return customStyles;
});

var CustomButtonTab = styled__default.button(_templateObject4, removeLinkEffects, tabStyle);

var secondaryStyle = styled.css(_templateObject5, CustomNavLink, CustomButtonTab, __chunk_1.theme.colors.GRAY_LIGHT_2, __chunk_1.theme.colors.INFO_COLOR);

var TabsContainer = styled__default.div(_templateObject3, __chunk_3.globalStyle(), __chunk_3.flexPosition({ align: 'flex-end', justify: 'flex-start' }), function (_ref11) {
  var secondary = _ref11.secondary;
  return secondary ? secondaryStyle : {};
});

exports.CustomNavLink = CustomNavLink;
exports.CustomButtonTab = CustomButtonTab;
exports.TabsContainer = TabsContainer;
//# sourceMappingURL=chunk-89ffa75e.js.map
