import styled from 'styled-components';
import { a as theme } from '../../chunk-a66336c0.js';
import { b as fontStyle, a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import AlertIcon from '../Icons/Alert/index.js';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n  background-color: ', ';\n  border-radius: ', ';\n  ', '\n  ', '\n  line-height: 17px;\n  padding: 15px 20px 15px 15px;\n  width: ', ';\n\n  ', '\n\n  > svg {\n    flex-shrink: 0;\n    margin-right: 15px;\n  }\n'], ['\n  ', '\n  background-color: ', ';\n  border-radius: ', ';\n  ', '\n  ', '\n  line-height: 17px;\n  padding: 15px 20px 15px 15px;\n  width: ', ';\n\n  ', '\n\n  > svg {\n    flex-shrink: 0;\n    margin-right: 15px;\n  }\n']);

var Alert = styled.div(_templateObject, globalStyle(), function (_ref) {
  var secondary = _ref.secondary,
      backgroundColor = _ref.backgroundColor;
  return secondary ? theme.colors.WHITE : backgroundColor;
}, theme.borders.RADIUS_1, flexPosition({ align: 'center' }), function (_ref2) {
  var secondary = _ref2.secondary,
      fontColor = _ref2.fontColor;
  return fontStyle(secondary ? theme.colors.DANGER_COLOR : fontColor, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD);
}, function (_ref3) {
  var width = _ref3.width;
  return width;
}, function (_ref4) {
  var customStyles = _ref4.customStyles;
  return customStyles;
});

var Alert$1 = function Alert$$1(_ref) {
  var id = _ref.id,
      className = _ref.className,
      fontColor = _ref.fontColor,
      backgroundColor = _ref.backgroundColor,
      iconColor = _ref.iconColor,
      iconSize = _ref.iconSize,
      secondary = _ref.secondary,
      customStyles = _ref.customStyles,
      children = _ref.children,
      width = _ref.width;
  return React.createElement(
    Alert,
    {
      id: id,
      className: 'alert-4all ' + className,
      backgroundColor: backgroundColor,
      fontColor: fontColor,
      customStyles: customStyles,
      secondary: secondary,
      width: width
    },
    React.createElement(AlertIcon, {
      size: iconSize,
      className: 'alert-icon',
      color: secondary ? theme.colors.DANGER_COLOR : iconColor
    }),
    children
  );
};

Alert$1.propTypes = {
  id: PropTypes.string,
  className: PropTypes.string,
  fontColor: PropTypes.string,
  backgroundColor: PropTypes.string,
  iconColor: PropTypes.string,
  iconSize: PropTypes.string,
  secondary: PropTypes.bool,
  customStyles: PropTypes.object,
  children: PropTypes.any.isRequired,
  width: PropTypes.string
};

Alert$1.defaultProps = {
  id: '',
  className: '',
  fontColor: theme.colors.WHITE,
  backgroundColor: theme.colors.DANGER_COLOR,
  iconColor: theme.colors.WHITE,
  iconSize: '30px',
  secondary: false,
  customStyles: {},
  width: '250px'
};

export default Alert$1;
//# sourceMappingURL=index.js.map
