import styled, { css } from 'styled-components';
import { a as flexPosition, b as fontStyle, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as lightenDarkenColor } from '../../chunk-522b50d9.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import Loader from '../Loader/index.js';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n  border: 1px solid ', ';\n  background-color: transparent;\n\n  &:hover {\n    background-color: transparent;\n  }\n'], ['\n  ', '\n  border: 1px solid ', ';\n  background-color: transparent;\n\n  &:hover {\n    background-color: transparent;\n  }\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  &:hover {\n    background-color: ', ';\n  }\n'], ['\n  &:hover {\n    background-color: ', ';\n  }\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  background-color: transparent;\n  border: none;\n  color: ', ';\n  font-size: ', ';\n  min-height: auto;\n  min-width: auto;\n  padding: 0;\n\n  &:hover {\n    background-color: transparent;\n  }\n'], ['\n  background-color: transparent;\n  border: none;\n  color: ', ';\n  font-size: ', ';\n  min-height: auto;\n  min-width: auto;\n  padding: 0;\n\n  &:hover {\n    background-color: transparent;\n  }\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', '\n  position: relative;\n  ', '\n  ', '\n  min-width: 40px;\n  min-height: 40px;\n  height: ', ';\n  width: ', ';\n  background-color: ', ';\n  border: ', ';\n  border-radius: ', ';\n  padding: 0 10px;\n  cursor: ', ';\n  transition: background-color 0.3s ease, color 0.3s ease, border 0.3s ease, width 0.3s ease, height 0.3s ease;\n  i {\n    margin-right: ', ';\n  }\n  ', '\n  ', ';\n  ', ';\n  ', ';\n  ', ';\n'], ['\n  ', '\n  position: relative;\n  ', '\n  ', '\n  min-width: 40px;\n  min-height: 40px;\n  height: ', ';\n  width: ', ';\n  background-color: ', ';\n  border: ', ';\n  border-radius: ', ';\n  padding: 0 10px;\n  cursor: ', ';\n  transition: background-color 0.3s ease, color 0.3s ease, border 0.3s ease, width 0.3s ease, height 0.3s ease;\n  i {\n    margin-right: ', ';\n  }\n  ', '\n  ', ';\n  ', ';\n  ', ';\n  ', ';\n']);

var secondaryButton = css(_templateObject, fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_6, theme.fontWeights.SEMIBOLD), theme.colors.GRAY_LIGHT_2);

var hoverButton = css(_templateObject2, function (_ref) {
  var bgColor = _ref.bgColor,
      customStyles = _ref.customStyles;
  return customStyles && customStyles.backgroundColor // eslint-disable-line
  ? customStyles.backgroundColor === '#000000' ? lightenDarkenColor(customStyles.backgroundColor, 30) : lightenDarkenColor(customStyles.backgroundColor, -30) : bgColor === '#000000' ? lightenDarkenColor(bgColor, 30) : lightenDarkenColor(bgColor, -30);
});

var linkButton = css(_templateObject3, theme.colors.INFO_COLOR, theme.fontSizes.SIZE_7);

var CustomButton = styled.button(_templateObject4, globalStyle(), flexPosition({ align: 'center', justify: 'center' }), function (_ref2) {
  var color = _ref2.color,
      fontSize = _ref2.fontSize,
      fontWeight = _ref2.fontWeight;
  return fontStyle(color || theme.colors.WHITE, fontSize || theme.fontSizes.SIZE_6, fontWeight || theme.fontWeights.SEMIBOLD);
}, function (_ref3) {
  var height = _ref3.height;
  return height || 'auto';
}, function (_ref4) {
  var width = _ref4.width;
  return width || 'auto';
}, function (_ref5) {
  var bgColor = _ref5.bgColor;
  return bgColor || theme.colors.MAIN_COLOR;
}, function (_ref6) {
  var border = _ref6.border,
      borderColor = _ref6.borderColor,
      bgColor = _ref6.bgColor;
  return border || '1px solid ' + (borderColor || bgColor || theme.colors.MAIN_COLOR);
}, theme.borders.RADIUS_1, function (_ref7) {
  var disabled = _ref7.disabled;
  return disabled ? 'not-allowed' : 'pointer';
}, function (_ref8) {
  var isLoading = _ref8.isLoading;
  return isLoading ? '10px' : '0px';
}, function (_ref9) {
  var noHover = _ref9.noHover;
  return !noHover ? hoverButton : {};
}, function (_ref10) {
  var secondary = _ref10.secondary;
  return secondary ? secondaryButton : {};
}, function (_ref11) {
  var disabled = _ref11.disabled,
      secondary = _ref11.secondary;
  return disabled ? '\n    border: 1px solid ' + theme.colors.GRAY_LIGHT_2 + ';\n    background-color: ' + (secondary ? theme.colors.WHITE : theme.colors.GRAY_LIGHT_2) + ';\n    color: ' + (secondary ? 'rgba(51, 51, 51, 0.30)' : theme.colors.WHITE) + ';\n\n    &:hover {\n      background-color: ' + (secondary ? theme.colors.WHITE : theme.colors.GRAY_LIGHT_2) + ';\n    }\n    ' : {};
}, function (_ref12) {
  var link = _ref12.link;
  return link && linkButton;
}, function (_ref13) {
  var customStyles = _ref13.customStyles;
  return customStyles;
});

var Button = function Button(_ref) {
  var id = _ref.id,
      className = _ref.className,
      isLoading = _ref.isLoading,
      type = _ref.type,
      width = _ref.width,
      height = _ref.height,
      borderColor = _ref.borderColor,
      bgColor = _ref.bgColor,
      disabled = _ref.disabled,
      customStyles = _ref.customStyles,
      onClick = _ref.onClick,
      color = _ref.color,
      border = _ref.border,
      children = _ref.children,
      secondary = _ref.secondary,
      loaderSize = _ref.loaderSize,
      loaderWidth = _ref.loaderWidth,
      noHover = _ref.noHover,
      link = _ref.link,
      tabIndex = _ref.tabIndex;
  return React.createElement(
    CustomButton,
    {
      id: id,
      className: 'btn-4all ' + className,
      color: color,
      type: type,
      width: width,
      height: height,
      borderColor: borderColor,
      bgColor: bgColor,
      border: border,
      isLoading: isLoading,
      disabled: disabled,
      customStyles: customStyles,
      onClick: onClick,
      secondary: secondary,
      loaderSize: loaderSize,
      loaderWidth: loaderWidth,
      noHover: noHover,
      link: link,
      tabIndex: tabIndex
    },
    isLoading && React.createElement(Loader, { size: loaderSize, color: color, width: loaderWidth }),
    children
  );
};

Button.propTypes = {
  id: PropTypes.string,
  className: PropTypes.string,
  color: PropTypes.string,
  type: PropTypes.string,
  width: PropTypes.string,
  height: PropTypes.string,
  borderColor: PropTypes.string,
  bgColor: PropTypes.string,
  border: PropTypes.string,
  isLoading: PropTypes.bool,
  disabled: PropTypes.bool,
  customStyles: PropTypes.object,
  onClick: PropTypes.func.isRequired,
  children: PropTypes.any.isRequired,
  secondary: PropTypes.bool,
  loaderSize: PropTypes.string,
  loaderWidth: PropTypes.string,
  noHover: PropTypes.bool,
  link: PropTypes.bool,
  tabIndex: PropTypes.string
};

Button.defaultProps = {
  id: null,
  className: null,
  color: '#FFF',
  type: 'button',
  width: 'auto',
  height: 'auto',
  borderColor: '',
  border: '1px solid ' + theme.colors.MAIN_COLOR,
  bgColor: theme.colors.MAIN_COLOR,
  isLoading: false,
  disabled: false,
  customStyles: {},
  secondary: false,
  loaderSize: '20px',
  loaderWidth: '3px',
  noHover: false,
  link: false,
  tabIndex: '0'
};

export default Button;
//# sourceMappingURL=index.js.map
