import styled from 'styled-components';
import { a as theme } from '../../chunk-a66336c0.js';
import { b as fontStyle, a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n\n'], ['\n  ', '\n\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  opacity: 0;\n  position: absolute;\n'], ['\n  opacity: 0;\n  position: absolute;\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  background-color: ', ';\n  border: 1px solid ', ';\n  border-radius: ', ';\n  display: block;\n  height: 18px;\n  position: relative;\n  width: 18px;\n\n  &::after,\n  &::before {\n    background-color: transparent;\n    border-radius: 0;\n    box-sizing: border-box;\n    content: \'\';\n    position: absolute;\n  }\n\n  &::before {\n    height: 2px;\n    left: 50%;\n    top: 50%;\n    transform: translate(-50%, -50%);\n    width: 12px;\n  }\n\n  &::after {\n    border-bottom: 2px solid transparent;\n    border-right: 2px solid transparent;\n    height: 12px;\n    left: 6px;\n    top: 0;\n    transform: rotate(45deg);\n    width: 6px;\n  }\n\n  ', ':focus ~ & {\n    outline-width: 2px;\n    outline-style: solid;\n    outline-color: Highlight;\n  }\n'], ['\n  background-color: ', ';\n  border: 1px solid ', ';\n  border-radius: ', ';\n  display: block;\n  height: 18px;\n  position: relative;\n  width: 18px;\n\n  &::after,\n  &::before {\n    background-color: transparent;\n    border-radius: 0;\n    box-sizing: border-box;\n    content: \'\';\n    position: absolute;\n  }\n\n  &::before {\n    height: 2px;\n    left: 50%;\n    top: 50%;\n    transform: translate(-50%, -50%);\n    width: 12px;\n  }\n\n  &::after {\n    border-bottom: 2px solid transparent;\n    border-right: 2px solid transparent;\n    height: 12px;\n    left: 6px;\n    top: 0;\n    transform: rotate(45deg);\n    width: 6px;\n  }\n\n  ', ':focus ~ & {\n    outline-width: 2px;\n    outline-style: solid;\n    outline-color: Highlight;\n  }\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  margin-right: 8px;\n  position: relative;\n'], ['\n  margin-right: 8px;\n  position: relative;\n']),
    _templateObject5 = taggedTemplateLiteral(['\n  ', '\n\n  ', '    \n\n  ', '\n'], ['\n  ', '\n\n  ', '    \n\n  ', '\n']),
    _templateObject6 = taggedTemplateLiteral(['\n  ', '\n  display: inline-block;\n'], ['\n  ', '\n  display: inline-block;\n']);

var getIcon = function getIcon(mixed, checked) {
  if (checked && mixed) {
    return '\n      &::before {\n        background-color: ' + theme.colors.WHITE + ';\n      }\n    ';
  }

  if (checked) {
    return '\n      &::after {\n        border-bottom-color: ' + theme.colors.WHITE + ';\n        border-right-color: ' + theme.colors.WHITE + ';\n      }\n    ';
  }

  return '';
};

var getColor = function getColor(disabled, checked) {
  var borderStyle = 'border-color: ' + theme.colors.GRAY_LIGHT_2 + ';';

  if (disabled) {
    return '\n      ' + borderStyle + '\n      background-color: ' + theme.colors.GRAY_LIGHT_2 + ';\n    ';
  }

  if (checked) {
    return '\n      border-color: ' + theme.colors.MAIN_COLOR + ';\n      background-color: ' + theme.colors.MAIN_COLOR + ';\n    ';
  }

  return '\n    ' + borderStyle + '\n    background-color: ' + theme.colors.WHITE + ';\n  ';
};

var Label = styled.span(_templateObject, fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_7, theme.fontWeights.NORMAL));

var Input = styled.input(_templateObject2);

var Checkbox = styled.span(_templateObject3, theme.colors.WHITE, theme.colors.GRAY_LIGHT_2, theme.borders.RADIUS_1, Input);

var InputContainer = styled.span(_templateObject4);

var CheckboxContainer = styled.label(_templateObject5, flexPosition({ align: 'center' }), function (_ref) {
  var disabled = _ref.disabled,
      mixed = _ref.mixed,
      checked = _ref.checked;
  return '\n    ' + Checkbox + ' {\n      ' + getColor(disabled, checked) + '\n      ' + getIcon(mixed, checked) + '\n      cursor: ' + (disabled ? 'default' : 'pointer') + ';\n    }\n  ';
}, function (_ref2) {
  var customStyles = _ref2.customStyles;
  return customStyles;
});

var Container = styled.div(_templateObject6, globalStyle());

var Checkbox$1 = function Checkbox$$1(_ref) {
  var id = _ref.id,
      label = _ref.label,
      name = _ref.name,
      checked = _ref.checked,
      mixed = _ref.mixed,
      className = _ref.className,
      disabled = _ref.disabled,
      customStyles = _ref.customStyles,
      onChange = _ref.onChange;

  var formattedId = 'checkbox-' + (id || name);

  return React.createElement(
    Container,
    null,
    React.createElement(
      CheckboxContainer,
      {
        htmlFor: formattedId,
        className: 'checkbox-4all checkbox--' + (!checked ? 'unchecked' : 'checked') + ' ' + className,
        customStyles: customStyles,
        disabled: disabled,
        mixed: mixed,
        checked: checked
      },
      React.createElement(
        InputContainer,
        null,
        React.createElement(Input, {
          id: formattedId,
          name: name,
          type: 'checkbox',
          checked: checked,
          onChange: onChange,
          disabled: disabled
        }),
        React.createElement(Checkbox, { className: 'checkbox-check' })
      ),
      React.createElement(
        Label,
        { className: 'checkbox-label' },
        label
      )
    )
  );
};

Checkbox$1.propTypes = {
  id: PropTypes.any,
  name: PropTypes.string,
  checked: PropTypes.bool,
  mixed: PropTypes.bool,
  className: PropTypes.string,
  label: PropTypes.string,
  onChange: PropTypes.func.isRequired,
  disabled: PropTypes.bool,
  customStyles: PropTypes.object
};

Checkbox$1.defaultProps = {
  id: '',
  name: '',
  checked: false,
  mixed: false,
  className: '',
  label: '',
  disabled: false,
  customStyles: {}
};

export default Checkbox$1;
//# sourceMappingURL=index.js.map
