import styled, { css } from 'styled-components';
import { Link } from 'react-router-dom';
import { a as flexPosition, b as fontStyle, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import BreadCrumb from '../BreadCrumb/index.js';
import ArrowComponent from '../Icons/Arrow/index.js';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  display: flex;\n  align-items: center;\n  ', '\n'], ['\n  display: flex;\n  align-items: center;\n  ', '\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  ', '\n  background-color: #418b37;\n  height: 140px;\n'], ['\n  ', '\n  background-color: #418b37;\n  height: 140px;\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  padding-top: 25px;\n  display: flex;\n  justify-content: space-between;\n'], ['\n  padding-top: 25px;\n  display: flex;\n  justify-content: space-between;\n']),
    _templateObject5 = taggedTemplateLiteral(['\n  color: ', ';\n  flex-direction: column;\n  font-weight: ', ';\n  height: auto;\n'], ['\n  color: ', ';\n  flex-direction: column;\n  font-weight: ', ';\n  height: auto;\n']),
    _templateObject6 = taggedTemplateLiteral(['\n  color: ', ';\n  font-weight: ', ';\n  margin-top: 11px;\n  display: flex;\n  align-items: center;\n  height: auto;\n  font-size: 14px;\n'], ['\n  color: ', ';\n  font-weight: ', ';\n  margin-top: 11px;\n  display: flex;\n  align-items: center;\n  height: auto;\n  font-size: 14px;\n']),
    _templateObject7 = taggedTemplateLiteral(['\n  opacity: 0.5;\n  line-height: 17px;\n'], ['\n  opacity: 0.5;\n  line-height: 17px;\n']),
    _templateObject8 = taggedTemplateLiteral(['\n  display: block;\n  font-size: 25px;\n  line-height: 34px;\n'], ['\n  display: block;\n  font-size: 25px;\n  line-height: 34px;\n']),
    _templateObject9 = taggedTemplateLiteral(['\n  ', '\n  margin-top: 100px;\n'], ['\n  ', '\n  margin-top: 100px;\n']);

var Container = styled.div(_templateObject, function (_ref) {
  var containerStyles = _ref.containerStyles;
  return containerStyles;
});

var linkStyle = css(_templateObject2, fontStyle(theme.colors.WHITE, theme.fontSizes.SIZE_6, theme.fontWeights.SEMIBOLD));

var ExternalLink = styled.a(_templateObject, linkStyle);

var InternalLink = styled(Link)(_templateObject, linkStyle);

var Header = styled.div(_templateObject3, globalStyle());

var InnerHeader = styled.div(_templateObject4);

var LeftHeader = styled.div(_templateObject5, theme.colors.WHITE, theme.fontWeights.SEMIBOLD);

var RightHeader = styled.div(_templateObject6, theme.colors.WHITE, theme.fontWeights.SEMIBOLD);

var SmallHeader = styled.span(_templateObject7);

var Title = styled.span(_templateObject8);

var ContentLoader = styled.div(_templateObject9, flexPosition({ justify: 'center' }));

var renderBackLink = function renderBackLink(backLink) {
  return React.createElement(
    React.Fragment,
    null,
    backLink.external ? React.createElement(
      ExternalLink,
      { href: backLink.link },
      React.createElement(ArrowComponent, { rotate: 'left', size: '30' }),
      backLink.text
    ) : React.createElement(
      InternalLink,
      { to: backLink.link },
      React.createElement(ArrowComponent, { rotate: 'left', size: '30' }),
      backLink.text
    )
  );
};

function Header$1(_ref) {
  var breadcrumbLinks = _ref.breadcrumbLinks,
      title = _ref.title,
      backLink = _ref.backLink,
      containerStyles = _ref.containerStyles;

  return React.createElement(
    Header,
    null,
    React.createElement(
      Container,
      { containerStyles: containerStyles },
      React.createElement(
        InnerHeader,
        null,
        React.createElement(
          LeftHeader,
          null,
          React.createElement(
            SmallHeader,
            null,
            breadcrumbLinks.length && React.createElement(BreadCrumb, { links: breadcrumbLinks })
          ),
          React.createElement(
            Title,
            null,
            title
          )
        ),
        backLink && React.createElement(
          RightHeader,
          null,
          renderBackLink(backLink)
        )
      )
    )
  );
}

Header$1.defaultProps = {
  title: '',
  breadcrumbLinks: [{ external: true, link: '/', text: 'Home' }, { link: '/', text: 'Listagem' }],
  backLink: null,
  containerStyles: {
    width: '100%',
    margin: '0 auto',
    maxWidth: '1170px',
    padding: '0px 15px'
  }
};

Header$1.propTypes = {
  title: PropTypes.string,
  backLink: PropTypes.object,
  breadcrumbLinks: PropTypes.array,
  containerStyles: PropTypes.object
};

export default Header$1;
//# sourceMappingURL=index.js.map
