import React from 'react';
import styled from 'styled-components';
import PropTypes from 'prop-types';
import { a as theme } from '../../../chunk-a66336c0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../../chunk-a9eac9e3.js';

var _templateObject = taggedTemplateLiteral(['\n  transform-origin: center;\n  fill: #fff;\n  ', '\n  ', '\n  ', '\n  ', '\n\n'], ['\n  transform-origin: center;\n  fill: #fff;\n  ', '\n  ', '\n  ', '\n  ', '\n\n']);

var Arrow = styled.svg(_templateObject, function (props) {
  return props.direction === 'right' && '\n    transform: rotate(0deg);\n  ';
}, function (props) {
  return props.direction === 'left' && '\n    transform: rotate(-180deg);\n  ';
}, function (props) {
  return props.direction === 'up' && '\n    transform: rotate(-90deg);\n  ';
}, function (props) {
  return props.direction === 'down' && '\n    transform: rotate(90deg);\n  ';
});

var ArrowComponent = function ArrowComponent(_ref) {
  var color = _ref.color,
      size = _ref.size,
      rotate = _ref.rotate,
      opacity = _ref.opacity;

  return React.createElement(
    Arrow,
    {
      xmlns: 'http://www.w3.org/2000/svg',
      xmlnsXlink: 'http://www.w3.org/1999/xlink',
      width: size,
      height: size,
      direction: rotate,
      color: color,
      viewBox: '0 0 25 25'
    },
    React.createElement(
      'defs',
      null,
      React.createElement('path', {
        id: 'arrow-icon-path',
        d: 'M7.38 1.04l2.502 2.909a.833.833 0 01.001 1.085L7.381 7.958a.833.833 0 11-1.266-1.083l1.318-1.542H1.75a.833.833 0 110-1.666l5.69-.001-1.324-1.54A.833.833 0 017.38 1.04z'
      })
    ),
    React.createElement(
      'g',
      { fill: 'none', fillRule: 'evenodd', opacity: opacity, transform: 'translate(7 8)' },
      React.createElement(
        'mask',
        { id: 'arrow-icon-mask', fill: '#fff' },
        React.createElement('use', { xlinkHref: '#arrow-icon-path' })
      ),
      React.createElement('use', { fill: color, fillRule: 'nonzero', xlinkHref: '#arrow-icon-path' }),
      React.createElement(
        'g',
        { fill: color, mask: 'url(#arrow-icon-mask)' },
        React.createElement('path', { d: 'M-7-8h25v25H-7z' })
      )
    )
  );
};

ArrowComponent.defaultProps = {
  color: theme.colors.WHITE,
  size: '25',
  rotate: 'right',
  opacity: 1
};

ArrowComponent.propTypes = {
  color: PropTypes.string,
  size: PropTypes.string,
  rotate: PropTypes.string,
  opacity: PropTypes.number
};

export default ArrowComponent;
//# sourceMappingURL=index.js.map
