import React from 'react';
import PropTypes from 'prop-types';
import { a as theme } from '../../../chunk-a66336c0.js';

var InfoIcon = function InfoIcon(_ref) {
  var color = _ref.color,
      width = _ref.width,
      height = _ref.height;
  return React.createElement(
    'svg',
    {
      xmlns: 'http://www.w3.org/2000/svg',
      xmlnsXlink: 'http://www.w3.org/1999/xlink',
      width: width,
      height: height,
      viewBox: '0 0 20 20'
    },
    React.createElement(
      'defs',
      null,
      React.createElement('path', {
        id: 'info-icon',
        d: 'M10 18a8 8 0 1 1 0-16 8 8 0 0 1 0 16zm0-9a1 1 0 0 0-1 1v4a1 1 0 0 0 2 0v-4a1 1 0 0 0-1-1zm0-3a1 1 0 1 0 0 2 1 1 0 0 0 0-2z'
      })
    ),
    React.createElement(
      'g',
      { fill: 'none', fillRule: 'evenodd' },
      React.createElement(
        'mask',
        { id: 'info-icon-b', fill: '#fff' },
        React.createElement('use', { xlinkHref: '#info-icon' })
      ),
      React.createElement('use', { fill: '#979797', xlinkHref: '#info-icon' }),
      React.createElement(
        'g',
        { fill: color, mask: 'url(#info-icon-b)' },
        React.createElement('path', { d: 'M0 0h20v20H0z' })
      )
    )
  );
};

InfoIcon.propTypes = {
  color: PropTypes.string,
  width: PropTypes.string,
  height: PropTypes.string
};

InfoIcon.defaultProps = {
  color: theme.colors.MAIN_COLOR,
  width: '20px',
  height: '20px'
};

export default InfoIcon;
//# sourceMappingURL=index.js.map
