import React from 'react';
import PropTypes from 'prop-types';
import { a as theme } from '../../../chunk-a66336c0.js';

var SearchIcon = function SearchIcon(_ref) {
  var size = _ref.size,
      color = _ref.color,
      className = _ref.className;
  return React.createElement(
    'svg',
    {
      xmlns: 'http://www.w3.org/2000/svg',
      xmlnsXlink: 'http://www.w3.org/1999/xlink',
      width: size,
      height: size,
      viewBox: '0 0 30 30',
      className: 'search-icon ' + className
    },
    React.createElement(
      'defs',
      null,
      React.createElement('path', {
        id: 'search-icon-a',
        d: 'M11.18 20.097l-2.603 1.735a1 1 0 1 1-1.11-1.664l2.462-1.642a7 7 0 1 1 1.25 1.57zM15.977 20a5 5 0 1 0 0-10 5 5 0 0 0 0 10z'
      })
    ),
    React.createElement(
      'g',
      { fill: 'none', fillRule: 'evenodd' },
      React.createElement(
        'mask',
        { id: 'search-icon-b', fill: '#fff' },
        React.createElement('use', { xlinkHref: '#search-icon-a' })
      ),
      React.createElement('use', { fill: '#FFF', fillRule: 'nonzero', xlinkHref: '#search-icon-a' }),
      React.createElement(
        'g',
        { fill: color, mask: 'url(#search-icon-b)' },
        React.createElement('path', { d: 'M0 0h30v30H0z' })
      )
    )
  );
};

SearchIcon.propTypes = {
  size: PropTypes.string,
  color: PropTypes.string,
  className: PropTypes.string
};

SearchIcon.defaultProps = {
  size: '30px',
  color: theme.colors.MAIN_COLOR,
  className: ''
};

export default SearchIcon;
//# sourceMappingURL=index.js.map
