import styled from 'styled-components';
import { b as fontStyle, a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import IconCheck from '../Icons/Check/index.js';
import SearchIcon from '../Icons/Search/index.js';

var _templateObject = taggedTemplateLiteral(['\n  border: 1px solid\n    ', ';\n  border-radius: 3px;\n  ', ';\n  height: 40px;\n  max-width: 100%;\n  padding: 10px 15px;\n  ', '\n  width: 100%;\n\n  ', '\n\n  ::placeholder {\n    color: ', ';\n  }\n\n  :disabled {\n    background-color: ', ';\n  }\n'], ['\n  border: 1px solid\n    ', ';\n  border-radius: 3px;\n  ', ';\n  height: 40px;\n  max-width: 100%;\n  padding: 10px 15px;\n  ', '\n  width: 100%;\n\n  ', '\n\n  ::placeholder {\n    color: ', ';\n  }\n\n  :disabled {\n    background-color: ', ';\n  }\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  ', '\n  position: relative;\n  width: ', ';\n'], ['\n  ', '\n  position: relative;\n  width: ', ';\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  display: block;\n'], ['\n  display: block;\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', '\n  height: 40px;\n  position: absolute;\n  right: 0;\n  top: 0;\n  width: 47px;\n  background: transparent;\n  border: none;\n  outline: none;\n  ', '\n'], ['\n  ', '\n  height: 40px;\n  position: absolute;\n  right: 0;\n  top: 0;\n  width: 47px;\n  background: transparent;\n  border: none;\n  outline: none;\n  ', '\n']);

var Input = styled.input(_templateObject, function (_ref) {
  var error = _ref.error;
  return error ? theme.colors.DANGER_COLOR : theme.colors.GRAY_LIGHT_2;
}, fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD), function (_ref2) {
  var hasIcon = _ref2.hasIcon;
  return hasIcon && 'padding-right: 47px;';
}, function (_ref3) {
  var customStyles = _ref3.customStyles;
  return customStyles;
}, theme.colors.GRAY_MEDIUM, theme.colors.GRAY_LIGHT_2);

var Container = styled.div(_templateObject2, globalStyle(), function (_ref4) {
  var width = _ref4.width;
  return width;
});

var Icon = styled.img(_templateObject3);

var IconContainer = styled.button(_templateObject4, flexPosition({ align: 'center', justify: 'center' }), function (_ref5) {
  var hasClickFunction = _ref5.hasClickFunction;
  return hasClickFunction && 'cursor: pointer;';
});

var Input$1 = function Input$$1(_ref) {
  var id = _ref.id,
      name = _ref.name,
      type = _ref.type,
      value = _ref.value,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      placeholder = _ref.placeholder,
      maxLength = _ref.maxLength,
      disabled = _ref.disabled,
      error = _ref.error,
      checked = _ref.checked,
      customStyles = _ref.customStyles,
      className = _ref.className,
      width = _ref.width,
      search = _ref.search,
      customIcon = _ref.customIcon,
      onIconClick = _ref.onIconClick,
      iconColor = _ref.iconColor,
      required = _ref.required;

  var hasIcon = checked || search || customIcon;
  var hasClickFunction = !!onIconClick && typeof onIconClick === 'function';
  return React.createElement(
    Container,
    { width: width },
    React.createElement(Input, {
      id: id,
      name: name,
      type: type,
      value: value,
      onChange: onChange,
      onFocus: onFocus,
      placeholder: placeholder,
      maxLength: maxLength,
      disabled: disabled,
      error: error,
      hasIcon: hasIcon,
      customStyles: customStyles,
      className: 'input-4all ' + className,
      width: width,
      required: required
    }),
    hasIcon && React.createElement(
      IconContainer,
      {
        as: hasClickFunction ? 'button' : 'div',
        onClick: onIconClick,
        hasClickFunction: hasClickFunction
      },
      search && !checked && React.createElement(SearchIcon, { color: iconColor }),
      checked && React.createElement(IconCheck, { size: '30px', color: iconColor }),
      customIcon && customIcon
    )
  );
};

Input$1.propTypes = {
  id: PropTypes.string,
  name: PropTypes.string,
  type: PropTypes.string,
  value: PropTypes.any,
  onChange: PropTypes.func.isRequired,
  onFocus: PropTypes.func,
  placeholder: PropTypes.string,
  maxLength: PropTypes.string,
  disabled: PropTypes.bool,
  error: PropTypes.bool,
  checked: PropTypes.bool,
  customStyles: PropTypes.object,
  className: PropTypes.string,
  width: PropTypes.string,
  search: PropTypes.bool,
  customIcon: PropTypes.any,
  onIconClick: PropTypes.func,
  iconColor: PropTypes.string,
  required: PropTypes.bool
};

Input$1.defaultProps = {
  id: '',
  name: '',
  type: 'text',
  value: '',
  onFocus: null,
  placeholder: '',
  maxLength: '',
  disabled: false,
  error: false,
  checked: false,
  customStyles: {},
  className: '',
  width: '100%',
  search: false,
  customIcon: null,
  onIconClick: null,
  iconColor: theme.colors.MAIN_COLOR,
  required: false
};

export default Input$1;
//# sourceMappingURL=index.js.map
