import styled, { css } from 'styled-components';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import PhotoIcon from '../Icons/Photo/index.js';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n  background-color: ', ';\n  border-radius: ', ';\n  height: ', ';\n  width: ', ';\n\n  ', '\n'], ['\n  ', '\n  background-color: ', ';\n  border-radius: ', ';\n  height: ', ';\n  width: ', ';\n\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  display: block;\n  ', '\n'], ['\n  display: block;\n  ', '\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  color: ', ';\n  font-size: ', ';\n  line-height: 1;\n  margin: 0;\n  padding: 0 5px;\n  text-align: center;\n'], ['\n  color: ', ';\n  font-size: ', ';\n  line-height: 1;\n  margin: 0;\n  padding: 0 5px;\n  text-align: center;\n']);

var sharedStyles = function sharedStyles(size, backgroundColor, customStyles) {
  return css(_templateObject, globalStyle(), backgroundColor, theme.borders.RADIUS_1, size, size, customStyles);
};

var Image = styled.img(_templateObject2, function (_ref) {
  var size = _ref.size,
      backgroundColor = _ref.backgroundColor,
      customStyles = _ref.customStyles;
  return sharedStyles(size, backgroundColor, customStyles);
});

var EmptyImage = styled.div(_templateObject3, flexPosition({ align: 'center', direction: 'column', justify: 'center' }), function (_ref2) {
  var size = _ref2.size,
      backgroundColor = _ref2.backgroundColor,
      customStyles = _ref2.customStyles;
  return sharedStyles(size, backgroundColor, customStyles);
});

var Text = styled.p(_templateObject4, function (_ref3) {
  var fontColor = _ref3.fontColor;
  return fontColor;
}, function (_ref4) {
  var fontSize = _ref4.fontSize;
  return fontSize;
});

var ItemImage = function ItemImage(_ref) {
  var id = _ref.id,
      className = _ref.className,
      image = _ref.image,
      small = _ref.small,
      alt = _ref.alt,
      title = _ref.title,
      size = _ref.size,
      backgroundColor = _ref.backgroundColor,
      fontColor = _ref.fontColor,
      fontSize = _ref.fontSize,
      iconSize = _ref.iconSize,
      iconColor = _ref.iconColor,
      customStyles = _ref.customStyles,
      emptyText = _ref.emptyText,
      iconOnly = _ref.iconOnly,
      noImage = _ref.noImage,
      customDefaultIcon = _ref.customDefaultIcon,
      loading = _ref.loading;
  return image ? React.createElement(Image, {
    backgroundColor: backgroundColor,
    className: 'product-image-4all ' + className,
    id: id,
    small: small,
    src: image,
    alt: alt,
    title: title,
    loading: loading,
    customStyles: customStyles,
    size: small ? '40px' : size
  }) : React.createElement(
    EmptyImage,
    {
      backgroundColor: backgroundColor,
      className: 'product-image-4all product-image-4all--empty ' + className,
      id: id,
      small: small,
      size: small ? '40px' : size,
      iconOnly: iconOnly,
      customStyles: customStyles
    },
    customDefaultIcon,
    !noImage && !customDefaultIcon ? React.createElement(PhotoIcon, {
      className: 'product-image-default-4all__icon',
      color: iconColor,
      size: small ? '25px' : iconSize
    }) : null,
    !iconOnly && React.createElement(
      Text,
      { fontSize: fontSize, className: 'product-image-4all__text', fontColor: fontColor },
      emptyText
    )
  );
};

ItemImage.propTypes = {
  id: PropTypes.string,
  className: PropTypes.string,
  image: PropTypes.any,
  small: PropTypes.bool,
  alt: PropTypes.string,
  title: PropTypes.string,
  size: PropTypes.string,
  backgroundColor: PropTypes.string,
  fontColor: PropTypes.string,
  iconColor: PropTypes.string,
  fontSize: PropTypes.string,
  customStyles: PropTypes.object,
  iconSize: PropTypes.string,
  emptyText: PropTypes.string,
  iconOnly: PropTypes.bool,
  noImage: PropTypes.bool,
  customDefaultIcon: PropTypes.any,
  loading: PropTypes.oneOfType(['eager', 'lazy', 'auto'])
};

ItemImage.defaultProps = {
  id: '',
  className: '',
  image: null,
  small: false,
  alt: '',
  title: '',
  size: '68px',
  backgroundColor: theme.colors.GRAY_LIGHT_2,
  fontColor: theme.colors.GRAY_MEDIUM,
  iconColor: theme.colors.GRAY_MEDIUM,
  fontSize: '10px',
  customStyles: {},
  iconSize: '30px',
  emptyText: 'Sem foto',
  iconOnly: false,
  noImage: false,
  customDefaultIcon: null,
  loading: 'auto'
};

export default ItemImage;
//# sourceMappingURL=index.js.map
