import React from 'react';
import PropTypes from 'prop-types';
import { a as CustomNavLink, b as CustomButtonTab, c as TabsContainer } from '../../../chunk-967ebbae.js';
import 'styled-components';
import 'react-router-dom';
import '../../../chunk-6a2706e0.js';
import '../../../chunk-a66336c0.js';
import '../../../chunk-a9eac9e3.js';

var NavTab = function NavTab(_ref) {
  var id = _ref.id,
      className = _ref.className,
      children = _ref.children,
      customStyles = _ref.customStyles,
      path = _ref.path,
      exact = _ref.exact,
      activeStyle = _ref.activeStyle,
      hoverStyle = _ref.hoverStyle,
      width = _ref.width,
      height = _ref.height,
      hoverColor = _ref.hoverColor,
      activeBorderColor = _ref.activeBorderColor,
      noOutline = _ref.noOutline;
  return React.createElement(
    CustomNavLink,
    {
      id: id,
      className: className,
      exact: !!exact,
      activeClassName: 'active',
      to: path,
      customStyles: customStyles || undefined,
      activeStyle: activeStyle,
      hoverstyle: hoverStyle || undefined,
      width: width,
      height: height,
      hovercolor: hoverColor || undefined,
      activebordercolor: activeBorderColor || undefined,
      nooutline: noOutline || undefined
    },
    children
  );
};

NavTab.propTypes = {
  customStyles: PropTypes.object,
  children: PropTypes.any.isRequired,
  path: PropTypes.string,
  exact: PropTypes.bool,
  activeStyle: PropTypes.object,
  hoverStyle: PropTypes.object,
  width: PropTypes.string,
  height: PropTypes.string,
  hoverColor: PropTypes.string,
  activeBorderColor: PropTypes.string,
  noOutline: PropTypes.bool,
  id: PropTypes.string,
  className: PropTypes.string
};

NavTab.defaultProps = {
  customStyles: null,
  path: null,
  exact: false,
  activeStyle: null,
  hoverStyle: null,
  width: null,
  height: null,
  hoverColor: null,
  activeBorderColor: null,
  noOutline: false,
  id: '',
  className: ''
};

export default NavTab;
//# sourceMappingURL=index.js.map
