import styled from 'styled-components';
import { a as flexPosition, b as fontStyle, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n  ', ';\n'], ['\n  ', '\n  ', ';\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  position: absolute;\n  opacity: 0;\n  cursor: pointer;\n'], ['\n  position: absolute;\n  opacity: 0;\n  cursor: pointer;\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', '\n\n  border-radius: 100px;\n  cursor: pointer;\n  height: 18px;\n  position: relative;\n  width: 18px;\n'], ['\n  ', '\n\n  border-radius: 100px;\n  cursor: pointer;\n  height: 18px;\n  position: relative;\n  width: 18px;\n']),
    _templateObject5 = taggedTemplateLiteral(['\n  ', '\n  margin-right: 8px;\n  position: relative;\n\n  > ', ':focus ~ ', ' {\n    outline-width: 2px;\n    outline-style: solid;\n    outline-color: Highlight;\n  }\n'], ['\n  ', '\n  margin-right: 8px;\n  position: relative;\n\n  > ', ':focus ~ ', ' {\n    outline-width: 2px;\n    outline-style: solid;\n    outline-color: Highlight;\n  }\n']),
    _templateObject6 = taggedTemplateLiteral(['\n  ', '\n  flex-direction: column;\n  ', '\n'], ['\n  ', '\n  flex-direction: column;\n  ', '\n']);

var RadioContainer = styled.div(_templateObject, globalStyle(), flexPosition({ align: 'flex-start', justify: 'flex-start' }));

var RadioInput = styled.input(_templateObject2);

var Label = styled.span(_templateObject3, fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_7, theme.fontWeights.NORMAL));

var Desc = styled.span(_templateObject3, fontStyle(theme.colors.GRAY_MEDIUM, theme.fontSizes.SIZE_7, theme.fontWeights.NORMAL));

var LabelContainer = styled.label(_templateObject3, flexPosition({ align: 'flex-start', justify: 'flex-start' }));

var CustomRadio = styled.span(_templateObject4, function (_ref) {
  var checked = _ref.checked,
      disabled = _ref.disabled;

  var color = 'transparent';

  if (disabled) {
    color = theme.colors.GRAY_LIGHT_2;
  } else if (checked) {
    color = theme.colors.MAIN_COLOR;
  }

  return '\n      background-color: ' + color + ';\n      border: ' + (checked || disabled ? 'none' : '1px solid ' + theme.colors.GRAY_LIGHT_2) + ';\n    ';
});

var InputContainer = styled.span(_templateObject5, flexPosition({}), RadioInput, CustomRadio);

var DescContainer = styled.span(_templateObject6, flexPosition({}), function (_ref2) {
  var customDescStyles = _ref2.customDescStyles;
  return customDescStyles;
});

var Radio = function Radio(_ref) {
  var id = _ref.id,
      name = _ref.name,
      className = _ref.className,
      checked = _ref.checked,
      onChange = _ref.onChange,
      value = _ref.value,
      label = _ref.label,
      desc = _ref.desc,
      customDescStyles = _ref.customDescStyles,
      disabled = _ref.disabled;

  var idFormatted = 'radio-' + (id || value);

  return React.createElement(
    RadioContainer,
    {
      className: 'radio-4all radio-4all--' + (checked ? 'checked' : 'unchecked') + ' ' + className
    },
    React.createElement(
      LabelContainer,
      { htmlFor: idFormatted },
      React.createElement(
        InputContainer,
        null,
        React.createElement(RadioInput, {
          id: idFormatted,
          type: 'radio',
          value: value,
          name: name,
          checked: checked,
          onChange: onChange,
          disabled: disabled
        }),
        React.createElement(CustomRadio, { checked: checked, disabled: disabled })
      ),
      React.createElement(
        DescContainer,
        { customDescStyles: customDescStyles },
        label && React.createElement(
          Label,
          { className: 'radio-4all-label' },
          label
        ),
        desc && React.createElement(
          Desc,
          { className: 'radio-4all-description' },
          desc
        )
      )
    )
  );
};

Radio.propTypes = {
  id: PropTypes.string,
  name: PropTypes.string,
  className: PropTypes.string,
  checked: PropTypes.bool,
  onChange: PropTypes.func.isRequired,
  value: PropTypes.any,
  label: PropTypes.string,
  desc: PropTypes.string,
  customDescStyles: PropTypes.object,
  disabled: PropTypes.bool
};

Radio.defaultProps = {
  id: '',
  name: '',
  className: '',
  checked: false,
  value: '',
  label: '',
  desc: '',
  customDescStyles: {},
  disabled: false
};

export default Radio;
//# sourceMappingURL=index.js.map
