import styled from 'styled-components';
import DebounceInput from 'react-debounce-input';
import { b as fontStyle, a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import CloseIcon from '../Icons/Close/index.js';
import SearchIcon from '../Icons/Search/index.js';

var _templateObject = taggedTemplateLiteral(['\n  border: 1px solid\n    ', ';\n  border-radius: 3px;\n  ', ';\n  height: 40px;\n  max-width: 100%;\n  padding: 10px 15px;\n  padding-right: 47px;\n  width: 100%;\n\n  ', '\n\n  ::placeholder {\n    color: ', ';\n  }\n\n  :disabled {\n    background-color: ', ';\n  }\n'], ['\n  border: 1px solid\n    ', ';\n  border-radius: 3px;\n  ', ';\n  height: 40px;\n  max-width: 100%;\n  padding: 10px 15px;\n  padding-right: 47px;\n  width: 100%;\n\n  ', '\n\n  ::placeholder {\n    color: ', ';\n  }\n\n  :disabled {\n    background-color: ', ';\n  }\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  ', '\n  position: relative;\n  width: ', ';\n'], ['\n  ', '\n  position: relative;\n  width: ', ';\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  display: block;\n'], ['\n  display: block;\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', '\n  height: 40px;\n  position: absolute;\n  right: 0;\n  top: 0;\n  width: 47px;\n  outline: none;\n  background-color: transparent;\n  border: none;\n'], ['\n  ', '\n  height: 40px;\n  position: absolute;\n  right: 0;\n  top: 0;\n  width: 47px;\n  outline: none;\n  background-color: transparent;\n  border: none;\n']),
    _templateObject5 = taggedTemplateLiteral(['\n  border: none;\n  background-color: transparent;\n  outline: none;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n'], ['\n  border: none;\n  background-color: transparent;\n  outline: none;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n']);

var Input = styled(DebounceInput)(_templateObject, function (_ref) {
  var error = _ref.error;
  return error ? theme.colors.DANGER_COLOR : theme.colors.GRAY_LIGHT_2;
}, fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD), function (_ref2) {
  var customStyles = _ref2.customStyles;
  return customStyles;
}, theme.colors.GRAY_MEDIUM, theme.colors.GRAY_LIGHT_2);

var Container = styled.div(_templateObject2, globalStyle(), function (_ref3) {
  var width = _ref3.width;
  return width;
});

var Icon = styled.img(_templateObject3);

var IconContainer = styled.button(_templateObject4, flexPosition({ align: 'center', justify: 'center' }));

var BtnAction = styled.button(_templateObject5);

var SearchInput = function SearchInput(_ref) {
  var id = _ref.id,
      name = _ref.name,
      type = _ref.type,
      value = _ref.value,
      onChange = _ref.onChange,
      onChangeAccessible = _ref.onChangeAccessible,
      onFocus = _ref.onFocus,
      placeholder = _ref.placeholder,
      maxLength = _ref.maxLength,
      disabled = _ref.disabled,
      error = _ref.error,
      customStyles = _ref.customStyles,
      className = _ref.className,
      width = _ref.width,
      debounceTimeout = _ref.debounceTimeout,
      minLength = _ref.minLength,
      iconColor = _ref.iconColor,
      onClearSearch = _ref.onClearSearch;

  var handleChange = function handleChange(e) {
    if (e.keyCode === 13) {
      onChangeAccessible();
    }
  };

  return React.createElement(
    Container,
    { width: width },
    React.createElement(Input, {
      id: id,
      name: name,
      type: type,
      value: value,
      onChange: onChange,
      onFocus: onFocus,
      placeholder: placeholder,
      onKeyDown: handleChange,
      maxLength: maxLength,
      disabled: disabled,
      error: error,
      customStyles: customStyles,
      className: 'input-4all ' + className,
      width: width,
      debounceTimeout: debounceTimeout,
      minLength: minLength
    }),
    React.createElement(
      IconContainer,
      null,
      value && onClearSearch ? React.createElement(
        BtnAction,
        { onClick: onClearSearch },
        React.createElement(CloseIcon, { color: theme.colors.GRAY_MEDIUM })
      ) : React.createElement(
        BtnAction,
        { onClick: onChangeAccessible },
        React.createElement(SearchIcon, { color: iconColor })
      )
    )
  );
};

SearchInput.propTypes = {
  id: PropTypes.string,
  name: PropTypes.string,
  type: PropTypes.string,
  value: PropTypes.any,
  onChange: PropTypes.func.isRequired,
  onFocus: PropTypes.func,
  placeholder: PropTypes.string,
  maxLength: PropTypes.string,
  disabled: PropTypes.bool,
  error: PropTypes.bool,
  customStyles: PropTypes.object,
  className: PropTypes.string,
  width: PropTypes.string,
  minLength: PropTypes.number,
  debounceTimeout: PropTypes.number,
  iconColor: PropTypes.string,
  onClearSearch: PropTypes.func,
  onChangeAccessible: PropTypes.func
};

SearchInput.defaultProps = {
  id: '',
  name: '',
  type: 'text',
  value: '',
  onFocus: null,
  placeholder: '',
  maxLength: '',
  disabled: false,
  error: false,
  customStyles: {},
  className: '',
  width: '100%',
  minLength: 0,
  debounceTimeout: 300,
  iconColor: theme.colors.MAIN_COLOR,
  onClearSearch: null,
  onChangeAccessible: function onChangeAccessible() {}
};

export default SearchInput;
//# sourceMappingURL=index.js.map
