import styled from 'styled-components';
import { a as theme } from '../../../chunk-a66336c0.js';
import { a as flexPosition, b as fontStyle } from '../../../chunk-6a2706e0.js';
import { a as lightenDarkenColor } from '../../../chunk-522b50d9.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../../chunk-a9eac9e3.js';
import React, { Fragment } from 'react';
import { components } from 'react-select';
import IconCheck from '../../Icons/Check/index.js';
import IconChevron from '../../Icons/Chevron/index.js';

var _templateObject = taggedTemplateLiteral(['\n  ', '\n  ', '\n  position: absolute;\n  right: 0px;\n  border-radius: 100%;\n  padding: 0px 4px;\n  height: 20px;\n'], ['\n  ', '\n  ', '\n  position: absolute;\n  right: 0px;\n  border-radius: 100%;\n  padding: 0px 4px;\n  height: 20px;\n']);

var groupStyles = {
  alignItems: 'center',
  display: 'flex'
};

var GroupLabel = {
  color: theme.colors.GRAY_MEDIUM,
  fontFamily: theme.fontFamily,
  fontSize: theme.fontSizes.SIZE_7,
  fontWeight: theme.fontWeights.SEMIBOLD,
  textTransform: 'initial'
};

var dotLabel = function dotLabel(options) {
  return options && {
    alignItems: 'center',
    display: 'flex',
    justifyContent: 'flex-start',

    ':before': {
      backgroundColor: options.color,
      border: '1px solid ' + (options.borderColor || options.color),
      borderRadius: '50%',
      content: '""',
      display: 'block',
      marginRight: options.margin || 10,
      height: options.size || 10,
      width: options.size || 10
    }
  };
};

var customStyles = function customStyles(_ref) {
  var error = _ref.error,
      _ref$customStyle = _ref.customStyle,
      customStyle = _ref$customStyle === undefined ? {} : _ref$customStyle,
      canRemove = _ref.canRemove,
      optionCustomDisabledStyles = _ref.optionCustomDisabledStyles,
      containerCustomStyles = _ref.containerCustomStyles,
      _ref$dotOptions = _ref.dotOptions,
      dotOptions = _ref$dotOptions === undefined ? {
    singleValueDot: true
  } : _ref$dotOptions;
  return {
    container: function container(styles) {
      return _extends({}, styles, containerCustomStyles, {
        width: customStyle.width || '100%'
      });
    },
    group: function group(styles) {
      return _extends({}, styles, {
        padding: '4px 0'
      });
    },
    option: function option(stylesProvided, _ref2) {
      var data = _ref2.data,
          isFocused = _ref2.isFocused,
          isDisabled = _ref2.isDisabled;
      return _extends({}, stylesProvided, {
        fontFamily: theme.fontFamily,
        color: isDisabled ? theme.colors.GRAY_MEDIUM_3 : theme.colors.GRAY_DARKER,
        cursor: isDisabled ? 'default' : 'pointer',
        textDecoration: isDisabled ? 'line-through' : '',
        display: 'flex',
        justifyContent: 'space-between',
        alignItems: 'center',
        backgroundColor: isFocused ? theme.colors.GRAY_LIGHT : '#FFF',
        padding: '4px 12px',
        height: customStyle.optionHeight || theme.input.DEFAULT_HEIGHT,
        ':active': {
          backgroundColor: theme.colors.GRAY_LIGHT_2
        },
        label: _extends({
          fontSize: theme.fontSizes.SIZE_7,
          fontWeight: 'normal',
          marginBottom: 0,
          cursor: isDisabled ? 'default' : 'pointer'
        }, dotLabel(data && data.dot))
      }, isDisabled ? optionCustomDisabledStyles : {});
    },
    control: function control() {
      return {
        width: '' + (customStyle.width ? parseInt(customStyle.width) - 2 + 'px' : '100%'),
        height: customStyle.height || 40,
        display: 'flex',
        border: '1px solid ' + (error ? theme.colors.DANGER_COLOR : customStyle.borderColor || theme.colors.GRAY_LIGHT_2),
        borderRadius: theme.borders.RADIUS_1
      };
    },
    multiValue: function multiValue(styles) {
      return _extends({}, styles, {
        backgroundColor: customStyle.valueBgColor || theme.colors.MAIN_COLOR,
        borderRadius: '15px',
        padding: '0px 0px 0px 5px',
        fontSize: theme.fontSizes.SIZE_7,
        fontWeight: theme.fontWeights.SEMIBOLD,
        fontFamily: theme.fontFamily,
        marginRight: '3px'
      }, customStyle.customValueStyles);
    },
    multiValueLabel: function multiValueLabel(styles) {
      return _extends({}, styles, {
        color: customStyle.valueColor || '#FFF',
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSizes.SIZE_7,
        fontWeight: theme.fontWeights.SEMIBOLD,
        padding: 5,
        paddingRight: 0,
        paddingLeft: '2px'
      });
    },
    noOptionsMessage: function noOptionsMessage(styles) {
      return _extends({}, styles, {
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSizes.SIZE_7,
        fontWeight: theme.fontWeights.SEMIBOLD
      });
    },
    multiValueRemove: function multiValueRemove(styles) {
      return !canRemove ? {
        display: 'none'
      } : _extends({}, styles, {
        color: customStyle.multiRemoveBgColor || '#FFF',
        borderTopRightRadius: '15px',
        borderBottomRightRadius: '15px',
        cursor: 'pointer',
        paddingLeft: '2px',
        marginLeft: '2px',
        ':hover': {
          backgroundColor: lightenDarkenColor(customStyle.valueBgColor || theme.colors.MAIN_COLOR)
        }
      });
    },
    placeholder: function placeholder(styles) {
      return _extends({}, styles, {
        fontSize: theme.fontSizes.SIZE_7,
        color: theme.colors.GRAY_MEDIUM,
        fontFamily: theme.fontFamily,
        fontWeight: theme.fontWeights.SEMIBOLD
      }, customStyle.customPlaceholderStyles);
    },
    valueContainer: function valueContainer(styles) {
      return _extends({}, styles, {
        paddingRight: '20px'
      }, customStyle.customValueContainerStyles, {
        /* flexWrap: 'nowrap', */
        '.select__single-value': _extends({
          fontSize: theme.fontSizes.SIZE_7,
          fontWeight: theme.fontWeights.SEMIBOLD,
          color: customStyle.valueColor || theme.colors.GRAY_DARKER,
          backgroundColor: customStyle.valueBgColor || 'transparent',
          fontFamily: theme.fontFamily
        }, customStyle.customValueStyles)
      });
    },
    singleValue: function singleValue(styles, _ref3) {
      var data = _ref3.data;

      var newStyle = _extends({}, styles);

      if (dotOptions.singleValueDot) {
        newStyle = _extends({}, newStyle, dotLabel(data && data.dot));
      }

      return newStyle;
    },
    dropdownIndicator: function dropdownIndicator(styles) {
      return _extends({}, styles, customStyle.customDropdownIndicatorStyles);
    }
  };
};

var QtdOptions = styled.span(_templateObject, flexPosition({ align: 'center', justify: 'center' }), fontStyle(theme.colors.GRAY_DARKER, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD));

var Option = function Option(option, customStyle) {
  return React.createElement(
    components.Option,
    option,
    React.createElement(
      'label',
      null,
      option.label
    ),
    option.isSelected ? React.createElement(IconCheck, { color: customStyle.optionIconColor }) : null
  );
};

var DropdownIndicator = function DropdownIndicator(props, customStyle) {
  return components.DropdownIndicator && React.createElement(
    components.DropdownIndicator,
    props,
    React.createElement(IconChevron, { color: customStyle.iconColor })
  );
};

var MultiValueLabel = function MultiValueLabel(props, formatLabel) {
  /* eslint-disable */
  var options = props.selectProps.value;
  var currOption = props.data;
  return formatLabel ? React.createElement(
    components.MultiValueLabel,
    _extends({ id: 'multi-value-' + currOption.value }, props),
    formatLabel(currOption, options)
  ) : React.createElement(
    Fragment,
    null,
    React.createElement(components.MultiValueLabel, _extends({ id: 'multi-value-' + currOption.value }, props))
  );
  /* eslint-enable */
};

var formatGroupLabel = function formatGroupLabel(data) {
  return React.createElement(
    'div',
    { style: groupStyles },
    React.createElement(
      'span',
      { style: GroupLabel },
      data.label
    )
  );
};

var ValueContainer = function ValueContainer(_ref // eslint-disable-line
) {
  var children = _ref.children,
      props = objectWithoutProperties(_ref, ['children']);
  return React.createElement(
    components.ValueContainer,
    props,
    children,
    React.createElement(QtdOptions, { className: 'multi-value-qtd-options' })
  );
};

export { groupStyles as a, GroupLabel as b, customStyles as c, QtdOptions as d, formatGroupLabel as e, DropdownIndicator as f, MultiValueLabel as g, ValueContainer as h, Option as i };
//# sourceMappingURL=index-879f6125.js.map
