'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var __chunk_1 = require('../../../chunk-f34490ab.js');
var __chunk_3 = require('../../../chunk-29a2e288.js');
var __chunk_4 = require('../../../chunk-63f79dee.js');
var __chunk_2 = require('../../../chunk-c6f22cfe.js');
var React = require('react');
var React__default = _interopDefault(React);
var ReactSelect = require('react-select');
var ReactSelect__default = _interopDefault(ReactSelect);
var index$1 = require('../../Icons/Check/index.js');
var index = require('../../Icons/Chevron/index.js');

var _templateObject = __chunk_2.taggedTemplateLiteral(['\n  ', '\n  ', '\n  position: absolute;\n  right: 0px;\n  border-radius: 100%;\n  padding: 0px 4px;\n  height: 20px;\n'], ['\n  ', '\n  ', '\n  position: absolute;\n  right: 0px;\n  border-radius: 100%;\n  padding: 0px 4px;\n  height: 20px;\n']);

var groupStyles = {
  alignItems: 'center',
  display: 'flex'
};

var GroupLabel = {
  color: __chunk_1.theme.colors.GRAY_MEDIUM,
  fontFamily: __chunk_1.theme.fontFamily,
  fontSize: __chunk_1.theme.fontSizes.SIZE_7,
  fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD,
  textTransform: 'initial'
};

var dotLabel = function dotLabel(options) {
  return options && {
    alignItems: 'center',
    display: 'flex',
    justifyContent: 'flex-start',

    ':before': {
      backgroundColor: options.color,
      border: '1px solid ' + (options.borderColor || options.color),
      borderRadius: '50%',
      content: '""',
      display: 'block',
      marginRight: options.margin || 10,
      height: options.size || 10,
      width: options.size || 10
    }
  };
};

var customStyles = function customStyles(_ref) {
  var error = _ref.error,
      _ref$customStyle = _ref.customStyle,
      customStyle = _ref$customStyle === undefined ? {} : _ref$customStyle,
      canRemove = _ref.canRemove,
      optionCustomDisabledStyles = _ref.optionCustomDisabledStyles,
      containerCustomStyles = _ref.containerCustomStyles,
      _ref$dotOptions = _ref.dotOptions,
      dotOptions = _ref$dotOptions === undefined ? {
    singleValueDot: true
  } : _ref$dotOptions;
  return {
    container: function container(styles) {
      return __chunk_2._extends({}, styles, containerCustomStyles, {
        width: customStyle.width || '100%'
      });
    },
    group: function group(styles) {
      return __chunk_2._extends({}, styles, {
        padding: '4px 0'
      });
    },
    option: function option(stylesProvided, _ref2) {
      var data = _ref2.data,
          isFocused = _ref2.isFocused,
          isDisabled = _ref2.isDisabled;
      return __chunk_2._extends({}, stylesProvided, {
        fontFamily: __chunk_1.theme.fontFamily,
        color: isDisabled ? __chunk_1.theme.colors.GRAY_MEDIUM_3 : __chunk_1.theme.colors.GRAY_DARKER,
        cursor: isDisabled ? 'default' : 'pointer',
        textDecoration: isDisabled ? 'line-through' : '',
        display: 'flex',
        justifyContent: 'space-between',
        alignItems: 'center',
        backgroundColor: isFocused ? __chunk_1.theme.colors.GRAY_LIGHT : '#FFF',
        padding: '4px 12px',
        height: customStyle.optionHeight || __chunk_1.theme.input.DEFAULT_HEIGHT,
        ':active': {
          backgroundColor: __chunk_1.theme.colors.GRAY_LIGHT_2
        },
        label: __chunk_2._extends({
          fontSize: __chunk_1.theme.fontSizes.SIZE_7,
          fontWeight: 'normal',
          marginBottom: 0,
          cursor: isDisabled ? 'default' : 'pointer'
        }, dotLabel(data && data.dot))
      }, isDisabled ? optionCustomDisabledStyles : {});
    },
    control: function control() {
      return {
        width: '' + (customStyle.width ? parseInt(customStyle.width) - 2 + 'px' : '100%'),
        height: customStyle.height || 40,
        display: 'flex',
        border: '1px solid ' + (error ? __chunk_1.theme.colors.DANGER_COLOR : customStyle.borderColor || __chunk_1.theme.colors.GRAY_LIGHT_2),
        borderRadius: __chunk_1.theme.borders.RADIUS_1
      };
    },
    multiValue: function multiValue(styles) {
      return __chunk_2._extends({}, styles, {
        backgroundColor: customStyle.valueBgColor || __chunk_1.theme.colors.MAIN_COLOR,
        borderRadius: '15px',
        padding: '0px 0px 0px 5px',
        fontSize: __chunk_1.theme.fontSizes.SIZE_7,
        fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD,
        fontFamily: __chunk_1.theme.fontFamily,
        marginRight: '3px'
      }, customStyle.customValueStyles);
    },
    multiValueLabel: function multiValueLabel(styles) {
      return __chunk_2._extends({}, styles, {
        color: customStyle.valueColor || '#FFF',
        fontFamily: __chunk_1.theme.fontFamily,
        fontSize: __chunk_1.theme.fontSizes.SIZE_7,
        fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD,
        padding: 5,
        paddingRight: 0,
        paddingLeft: '2px'
      });
    },
    noOptionsMessage: function noOptionsMessage(styles) {
      return __chunk_2._extends({}, styles, {
        fontFamily: __chunk_1.theme.fontFamily,
        fontSize: __chunk_1.theme.fontSizes.SIZE_7,
        fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD
      });
    },
    multiValueRemove: function multiValueRemove(styles) {
      return !canRemove ? {
        display: 'none'
      } : __chunk_2._extends({}, styles, {
        color: customStyle.multiRemoveBgColor || '#FFF',
        borderTopRightRadius: '15px',
        borderBottomRightRadius: '15px',
        cursor: 'pointer',
        paddingLeft: '2px',
        marginLeft: '2px',
        ':hover': {
          backgroundColor: __chunk_4.lightenDarkenColor(customStyle.valueBgColor || __chunk_1.theme.colors.MAIN_COLOR)
        }
      });
    },
    placeholder: function placeholder(styles) {
      return __chunk_2._extends({}, styles, {
        fontSize: __chunk_1.theme.fontSizes.SIZE_7,
        color: __chunk_1.theme.colors.GRAY_MEDIUM,
        fontFamily: __chunk_1.theme.fontFamily,
        fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD
      }, customStyle.customPlaceholderStyles);
    },
    valueContainer: function valueContainer(styles) {
      return __chunk_2._extends({}, styles, {
        paddingRight: '20px'
      }, customStyle.customValueContainerStyles, {
        /* flexWrap: 'nowrap', */
        '.select__single-value': __chunk_2._extends({
          fontSize: __chunk_1.theme.fontSizes.SIZE_7,
          fontWeight: __chunk_1.theme.fontWeights.SEMIBOLD,
          color: customStyle.valueColor || __chunk_1.theme.colors.GRAY_DARKER,
          backgroundColor: customStyle.valueBgColor || 'transparent',
          fontFamily: __chunk_1.theme.fontFamily
        }, customStyle.customValueStyles)
      });
    },
    singleValue: function singleValue(styles, _ref3) {
      var data = _ref3.data;

      var newStyle = __chunk_2._extends({}, styles);

      if (dotOptions.singleValueDot) {
        newStyle = __chunk_2._extends({}, newStyle, dotLabel(data && data.dot));
      }

      return newStyle;
    },
    dropdownIndicator: function dropdownIndicator(styles) {
      return __chunk_2._extends({}, styles, customStyle.customDropdownIndicatorStyles);
    }
  };
};

var QtdOptions = styled__default.span(_templateObject, __chunk_3.flexPosition({ align: 'center', justify: 'center' }), __chunk_3.fontStyle(__chunk_1.theme.colors.GRAY_DARKER, __chunk_1.theme.fontSizes.SIZE_7, __chunk_1.theme.fontWeights.SEMIBOLD));

var Option = function Option(option, customStyle) {
  return React__default.createElement(
    ReactSelect.components.Option,
    option,
    React__default.createElement(
      'label',
      null,
      option.label
    ),
    option.isSelected ? React__default.createElement(index$1.default, { color: customStyle.optionIconColor }) : null
  );
};

var DropdownIndicator = function DropdownIndicator(props, customStyle) {
  return ReactSelect.components.DropdownIndicator && React__default.createElement(
    ReactSelect.components.DropdownIndicator,
    props,
    React__default.createElement(index.default, { color: customStyle.iconColor })
  );
};

var MultiValueLabel = function MultiValueLabel(props, formatLabel) {
  /* eslint-disable */
  var options = props.selectProps.value;
  var currOption = props.data;
  return formatLabel ? React__default.createElement(
    ReactSelect.components.MultiValueLabel,
    __chunk_2._extends({ id: 'multi-value-' + currOption.value }, props),
    formatLabel(currOption, options)
  ) : React__default.createElement(
    React.Fragment,
    null,
    React__default.createElement(ReactSelect.components.MultiValueLabel, __chunk_2._extends({ id: 'multi-value-' + currOption.value }, props))
  );
  /* eslint-enable */
};

var formatGroupLabel = function formatGroupLabel(data) {
  return React__default.createElement(
    'div',
    { style: groupStyles },
    React__default.createElement(
      'span',
      { style: GroupLabel },
      data.label
    )
  );
};

var ValueContainer = function ValueContainer(_ref // eslint-disable-line
) {
  var children = _ref.children,
      props = __chunk_2.objectWithoutProperties(_ref, ['children']);
  return React__default.createElement(
    ReactSelect.components.ValueContainer,
    props,
    children,
    React__default.createElement(QtdOptions, { className: 'multi-value-qtd-options' })
  );
};

exports.groupStyles = groupStyles;
exports.GroupLabel = GroupLabel;
exports.customStyles = customStyles;
exports.QtdOptions = QtdOptions;
exports.formatGroupLabel = formatGroupLabel;
exports.DropdownIndicator = DropdownIndicator;
exports.MultiValueLabel = MultiValueLabel;
exports.ValueContainer = ValueContainer;
exports.Option = Option;
//# sourceMappingURL=index-db13d931.js.map
