import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React, { PureComponent } from 'react';
import ReactSelect from 'react-select';
import PropTypes from 'prop-types';
import { a as groupStyles, b as GroupLabel, c as customStyles, d as QtdOptions, e as formatGroupLabel, f as DropdownIndicator, g as MultiValueLabel, h as ValueContainer, i as Option } from './custom/index-879f6125.js';
import { a as theme } from '../../chunk-a66336c0.js';
import 'styled-components';
import '../../chunk-6a2706e0.js';
import '../../chunk-522b50d9.js';
import '../Icons/Check/index.js';
import '../Icons/Chevron/index.js';

var initSelectedOptions = function initSelectedOptions(options) {
  options.forEach(function (item) {
    item.style.display = 'flex';
  });
};

var getMaxOptions = function getMaxOptions() {
  var marginItem = 7;
  var marginContainer = 16;
  var paddingContainer = 32;
  var selectedOptions = document.getElementsByClassName('select__multi-value');
  initSelectedOptions([].concat(toConsumableArray(selectedOptions)));
  var multiContainerWidth = document.getElementsByClassName('select__value-container--is-multi')[0].offsetWidth + marginContainer - paddingContainer;
  var multiItemWidths = [].concat(toConsumableArray(selectedOptions)).map(function (item) {
    return item.offsetWidth + marginItem;
  });
  var sumWidth = 0;
  var maxOptions = 0;
  multiItemWidths.forEach(function (width) {
    sumWidth += width;
    if (sumWidth < multiContainerWidth - 10) {
      maxOptions += 1;
    } else {
      return; // eslint-disable-line
    }
  });

  return maxOptions;
};

var toggleOptionSelectedCounter = function toggleOptionSelectedCounter(totalOptions, maxOptions) {
  var qtdMoreValues = document.getElementsByClassName('multi-value-qtd-options')[0];

  if (qtdMoreValues && totalOptions > maxOptions) {
    qtdMoreValues.style.display = 'flex';
    qtdMoreValues.innerHTML = '+' + (totalOptions - maxOptions);
  } else if (qtdMoreValues) {
    qtdMoreValues.style.display = 'none';
  }
};

var formatSelectValues = function formatSelectValues() {
  var maxOptions = getMaxOptions();
  var selectedOptions = [].concat(toConsumableArray(document.getElementsByClassName('select__multi-value')));
  var totalOptions = selectedOptions.length;
  toggleOptionSelectedCounter(totalOptions, maxOptions);

  selectedOptions.forEach(function (item, index) {
    if (index + 1 > maxOptions) {
      item.style.display = 'none';
    } else {
      item.style.display = 'flex';
    }
  });
};

var Select = function (_PureComponent) {
  inherits(Select, _PureComponent);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.shouldFormatSelectValues = function () {
      var isMultiple = _this.props.isMultiple;

      if (isMultiple) {
        formatSelectValues();
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.shouldFormatSelectValues();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.shouldFormatSelectValues();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          id = _props.id,
          value = _props.value,
          name = _props.name,
          onChange = _props.onChange,
          isMultiple = _props.isMultiple,
          options = _props.options,
          placeholder = _props.placeholder,
          formatLabel = _props.formatLabel,
          error = _props.error,
          closeMenuOnSelect = _props.closeMenuOnSelect,
          customValueStyles = _props.customValueStyles,
          canRemove = _props.canRemove,
          valueBgColor = _props.valueBgColor,
          valueColor = _props.valueColor,
          multiRemoveBgColor = _props.multiRemoveBgColor,
          iconColor = _props.iconColor,
          optionIconColor = _props.optionIconColor,
          height = _props.height,
          optionCustomDisabledStyles = _props.optionCustomDisabledStyles,
          optionHeight = _props.optionHeight,
          disabled = _props.disabled,
          containerCustomStyles = _props.containerCustomStyles,
          dotOptions = _props.dotOptions,
          width = _props.width,
          borderColor = _props.borderColor,
          customPlaceholderStyles = _props.customPlaceholderStyles,
          customValueContainerStyles = _props.customValueContainerStyles,
          customDropdownIndicatorStyles = _props.customDropdownIndicatorStyles,
          isSearchable = _props.isSearchable;

      var style = {
        valueBgColor: valueBgColor,
        valueColor: valueColor,
        multiRemoveBgColor: multiRemoveBgColor,
        customValueStyles: customValueStyles,
        iconColor: iconColor,
        optionIconColor: optionIconColor,
        height: height,
        optionHeight: optionHeight,
        width: width,
        borderColor: borderColor,
        customPlaceholderStyles: customPlaceholderStyles,
        customValueContainerStyles: customValueContainerStyles,
        customDropdownIndicatorStyles: customDropdownIndicatorStyles
      };

      return React.createElement(ReactSelect, {
        id: 'select-' + id,
        name: name + '-' + id,
        onChange: onChange,
        options: options,
        value: value,
        isMulti: isMultiple,
        styles: customStyles({
          error: error,
          customStyle: style,
          canRemove: canRemove,
          optionCustomDisabledStyles: optionCustomDisabledStyles,
          containerCustomStyles: containerCustomStyles,
          dotOptions: dotOptions
        }),
        className: 'select-4all react-dropdown-multiselect',
        placeholder: placeholder,
        classNamePrefix: 'select',
        isClearable: false,
        clearable: false,
        hideSelectedOptions: false,
        closeMenuOnSelect: closeMenuOnSelect,
        formatGroupLabel: formatGroupLabel,
        isOptionDisabled: function isOptionDisabled(opt) {
          return opt.disabled;
        },
        isDisabled: disabled,
        components: {
          Option: function Option$$1(props) {
            return Option(props, style);
          },
          DropdownIndicator: function DropdownIndicator$$1(props) {
            return DropdownIndicator(props, style);
          },
          IndicatorSeparator: function IndicatorSeparator() {
            return null;
          },
          ValueContainer: ValueContainer,
          MultiValueLabel: function MultiValueLabel$$1(props) {
            return MultiValueLabel(props, formatLabel);
          }
        },
        isSearchable: isSearchable
      });
    }
  }]);
  return Select;
}(PureComponent);

Select.propTypes = {
  id: PropTypes.string,
  value: PropTypes.any,
  name: PropTypes.string,
  onChange: PropTypes.func.isRequired,
  error: PropTypes.bool,
  options: PropTypes.array,
  isMultiple: PropTypes.bool,
  placeholder: PropTypes.string,
  formatLabel: PropTypes.func,
  closeMenuOnSelect: PropTypes.bool,
  canRemove: PropTypes.bool,
  customValueStyles: PropTypes.object,
  valueBgColor: PropTypes.string,
  valueColor: PropTypes.string,
  multiRemoveBgColor: PropTypes.string,
  iconColor: PropTypes.string,
  height: PropTypes.string,
  optionHeight: PropTypes.string,
  optionCustomDisabledStyles: PropTypes.object,
  containerCustomStyles: PropTypes.object,
  customValueContainerStyles: PropTypes.object,
  customDropdownIndicatorStyles: PropTypes.object,
  customPlaceholderStyles: PropTypes.object,
  disabled: PropTypes.bool,
  optionIconColor: PropTypes.string,
  isSearchable: PropTypes.bool
};

Select.defaultProps = {
  options: [],
  isMultiple: false,
  placeholder: 'Selecione',
  error: false,
  closeMenuOnSelect: false,
  formatLabel: null,
  id: 'dropdown',
  name: '',
  value: null,
  canRemove: true,
  customValueStyles: {},
  valueBgColor: null,
  valueColor: null,
  multiRemoveBgColor: null,
  iconColor: theme.colors.MAIN_COLOR,
  optionIconColor: theme.colors.MAIN_COLOR,
  height: theme.input.DEFAULT_HEIGHT,
  optionHeight: theme.input.DEFAULT_HEIGHT,
  optionCustomDisabledStyles: {},
  customValueContainerStyles: {},
  customDropdownIndicatorStyles: {},
  customPlaceholderStyles: {},
  containerCustomStyles: {},
  disabled: false,
  isSearchable: true
};

export default Select;
//# sourceMappingURL=index.js.map
