import React from 'react';
import PropTypes from 'prop-types';
import { a as CustomNavLink, b as CustomButtonTab, c as TabsContainer } from '../../../chunk-967ebbae.js';
import 'styled-components';
import 'react-router-dom';
import '../../../chunk-6a2706e0.js';
import '../../../chunk-a66336c0.js';
import '../../../chunk-a9eac9e3.js';

var Tab = function Tab(_ref) {
  var id = _ref.id,
      className = _ref.className,
      children = _ref.children,
      customStyles = _ref.customStyles,
      active = _ref.active,
      onClick = _ref.onClick,
      activeStyle = _ref.activeStyle,
      hoverStyle = _ref.hoverStyle,
      width = _ref.width,
      height = _ref.height,
      hoverColor = _ref.hoverColor,
      activeBorderColor = _ref.activeBorderColor,
      noOutline = _ref.noOutline;
  return React.createElement(
    CustomButtonTab,
    {
      key: id,
      id: id,
      className: active ? 'active ' + className : className,
      customStyles: customStyles,
      activeStyle: activeStyle,
      hoverstyle: hoverStyle || undefined,
      width: width,
      height: height,
      hovercolor: hoverColor || undefined,
      activebordercolor: activeBorderColor || undefined,
      onClick: onClick,
      nooutline: noOutline || undefined
    },
    children
  );
};

Tab.propTypes = {
  customStyles: PropTypes.object,
  children: PropTypes.any.isRequired,
  onClick: PropTypes.func.isRequired,
  activeStyle: PropTypes.object,
  hoverStyle: PropTypes.object,
  width: PropTypes.string,
  height: PropTypes.string,
  hoverColor: PropTypes.string,
  activeBorderColor: PropTypes.string,
  active: PropTypes.bool,
  noOutline: PropTypes.bool,
  id: PropTypes.string,
  className: PropTypes.string
};

Tab.defaultProps = {
  id: '',
  className: '',
  customStyles: {},
  activeStyle: null,
  hoverStyle: null,
  width: null,
  height: null,
  hoverColor: null,
  activeBorderColor: null,
  active: false,
  noOutline: false
};

export default Tab;
//# sourceMappingURL=index.js.map
