import styled, { css } from 'styled-components';
import { b as fontStyle, a as flexPosition, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as theme } from '../../chunk-a66336c0.js';
import CloseIcon, { Icon } from '../Icons/Close/index.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';

var _templateObject = taggedTemplateLiteral(['\n  color: ', ';\n  background-color: ', ';\n  border-color: ', ';\n'], ['\n  color: ', ';\n  background-color: ', ';\n  border-color: ', ';\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  color: ', ';\n  background-color: transparent;\n  border-color: ', ';\n\n  &:hover {\n    background-color: transparent;\n  }\n'], ['\n  color: ', ';\n  background-color: transparent;\n  border-color: ', ';\n\n  &:hover {\n    background-color: transparent;\n  }\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  background-color: ', ';\n  border-color: ', ';\n  color: ', ';\n\n  &:hover {\n    background-color: ', ';\n  }\n'], ['\n  background-color: ', ';\n  border-color: ', ';\n  color: ', ';\n\n  &:hover {\n    background-color: ', ';\n  }\n']),
    _templateObject4 = taggedTemplateLiteral(['\n  display: block;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n'], ['\n  display: block;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n']),
    _templateObject5 = taggedTemplateLiteral(['\n  ', '\n  background-color: ', ';\n  border: ', ';\n  border-radius: 20px;\n  color: ', ';\n  ', '\n  ', '\n  height: ', ';\n  line-height: ', ';\n  margin-right: 10px;\n  margin-bottom: 10px;\n  min-width: 50px;\n  padding: ', ';\n  position: relative;\n  width: ', ';\n\n  &:hover {\n    ', ';\n  }\n\n  &:last-child {\n    margin-right: 0;\n  }\n\n  ', ' {\n    flex-shrink: 0;\n    margin: -1px 0 -1px 10px;\n  }\n  \n  ', '\n  ', ';\n  ', ';\n  ', '\n  max-width: ', ';\n  ', ';\n  ', ';\n'], ['\n  ', '\n  background-color: ', ';\n  border: ', ';\n  border-radius: 20px;\n  color: ', ';\n  ', '\n  ', '\n  height: ', ';\n  line-height: ', ';\n  margin-right: 10px;\n  margin-bottom: 10px;\n  min-width: 50px;\n  padding: ', ';\n  position: relative;\n  width: ', ';\n\n  &:hover {\n    ', ';\n  }\n\n  &:last-child {\n    margin-right: 0;\n  }\n\n  ', ' {\n    flex-shrink: 0;\n    margin: -1px 0 -1px 10px;\n  }\n  \n  ', '\n  ', ';\n  ', ';\n  ', '\n  max-width: ', ';\n  ', ';\n  ', ';\n']);

var errorTag = css(_templateObject, theme.colors.GRAY_LIGHT, theme.colors.DANGER_COLOR, theme.colors.DANGER_COLOR);

var secondaryTag = css(_templateObject2, theme.colors.GRAY_DARKER, theme.colors.GRAY_LIGHT_2);

var disabledStyle = css(_templateObject3, theme.colors.GRAY_LIGHT_2, theme.colors.GRAY_LIGHT_2, theme.colors.GRAY_MEDIUM_3, theme.colors.GRAY_LIGHT_2);

var ellipsisLimitation = css(_templateObject4);

var CustomTag = styled.div(_templateObject5, globalStyle(), function (_ref) {
  var bgColor = _ref.bgColor;
  return bgColor;
}, function (_ref2) {
  var border = _ref2.border;
  return border;
}, function (_ref3) {
  var color = _ref3.color;
  return color || theme.colors.WHITE;
}, flexPosition({ align: 'center', justify: 'center' }), fontStyle(function (_ref4) {
  var color = _ref4.color;
  return color;
}, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD), function (_ref5) {
  var height = _ref5.height;
  return height || 'auto';
}, function (_ref6) {
  var height = _ref6.height;
  return height || '17px';
}, function (_ref7) {
  var removeTag = _ref7.removeTag;
  return removeTag ? '0 5px 0 15px' : '3px 15px';
}, function (_ref8) {
  var width = _ref8.width;
  return width || 'auto';
}, function (_ref9) {
  var hoverStyle = _ref9.hoverStyle;
  return hoverStyle;
}, Icon, function (_ref10) {
  var removeTag = _ref10.removeTag;
  return removeTag ? 'justify-content: space-between' : {};
}, function (_ref11) {
  var error = _ref11.error;
  return error ? errorTag : {};
}, function (_ref12) {
  var secondary = _ref12.secondary;
  return secondary ? secondaryTag : {};
}, function (_ref13) {
  var withEllipsis = _ref13.withEllipsis;
  return withEllipsis ? ellipsisLimitation : {};
}, function (_ref14) {
  var maxWidth = _ref14.maxWidth;
  return maxWidth;
}, function (_ref15) {
  var disabled = _ref15.disabled;
  return disabled ? disabledStyle : {};
}, function (_ref16) {
  var customStyles = _ref16.customStyles;
  return customStyles;
});

var getIconColor = function getIconColor(_ref) {
  var iconColor = _ref.iconColor,
      disabled = _ref.disabled,
      secondary = _ref.secondary;

  if (iconColor) {
    return iconColor;
  }

  if (disabled || secondary) {
    return theme.colors.GRAY_MEDIUM_3;
  }

  return theme.colors.white;
};

var Tag = function Tag(_ref2) {
  var id = _ref2.id,
      tag = _ref2.tag,
      className = _ref2.className,
      color = _ref2.color,
      height = _ref2.height,
      width = _ref2.width,
      bgColor = _ref2.bgColor,
      border = _ref2.border,
      disabled = _ref2.disabled,
      customStyles = _ref2.customStyles,
      onHoverTag = _ref2.onHoverTag,
      onBlurTag = _ref2.onBlurTag,
      onClick = _ref2.onClick,
      onRemoveTag = _ref2.onRemoveTag,
      children = _ref2.children,
      secondary = _ref2.secondary,
      maxWidth = _ref2.maxWidth,
      withEllipsis = _ref2.withEllipsis,
      error = _ref2.error,
      iconColor = _ref2.iconColor;
  return React.createElement(
    CustomTag,
    {
      id: id,
      className: 'tag-4all ' + className,
      color: color,
      height: height,
      width: width,
      bgColor: bgColor,
      disabled: disabled,
      customStyles: customStyles,
      border: border,
      onMouseLeave: onBlurTag ? function () {
        return onBlurTag(tag);
      } : null,
      onMouseOver: onHoverTag ? function () {
        return onHoverTag(tag);
      } : null,
      onFocus: onHoverTag ? function () {
        return onHoverTag(tag);
      } : null,
      onClick: onClick,
      removeTag: !!onRemoveTag,
      secondary: secondary,
      maxWidth: maxWidth,
      withEllipsis: withEllipsis,
      error: error
    },
    children,
    !!onRemoveTag && React.createElement(CloseIcon, {
      color: getIconColor({
        iconColor: iconColor,
        disabled: disabled,
        secondary: secondary
      }),
      onClick: onRemoveTag
    })
  );
};

Tag.propTypes = {
  id: PropTypes.string,
  tag: PropTypes.object,
  className: PropTypes.string,
  color: PropTypes.string,
  width: PropTypes.string,
  height: PropTypes.string,
  bgColor: PropTypes.string,
  border: PropTypes.string,
  onHoverTag: PropTypes.func,
  onBlurTag: PropTypes.func,
  disabled: PropTypes.bool,
  customStyles: PropTypes.object,
  onClick: PropTypes.func,
  onRemoveTag: PropTypes.func,
  children: PropTypes.any.isRequired,
  secondary: PropTypes.bool,
  maxWidth: PropTypes.string,
  withEllipsis: PropTypes.bool,
  error: PropTypes.bool,
  iconColor: PropTypes.string
};

Tag.defaultProps = {
  id: null,
  tag: {},
  className: '',
  color: theme.colors.white,
  height: 'auto',
  width: 'auto',
  bgColor: theme.colors.MAIN_COLOR,
  disabled: false,
  border: '1px solid ' + theme.colors.MAIN_COLOR,
  onHoverTag: null,
  onBlurTag: null,
  onClick: null,
  onRemoveTag: null,
  customStyles: {},
  secondary: false,
  maxWidth: '',
  withEllipsis: false,
  error: false,
  iconColor: theme.colors.white
};

export default Tag;
//# sourceMappingURL=index.js.map
