import styled from 'styled-components';
import { a as theme } from '../../chunk-a66336c0.js';
import { b as fontStyle, d as globalStyle } from '../../chunk-6a2706e0.js';
import { a as classCallCheck, b as createClass, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as taggedTemplateLiteral, g as toConsumableArray, h as _extends } from '../../chunk-a9eac9e3.js';
import React from 'react';
import PropTypes from 'prop-types';
import InfoIcon from '../Icons/Info/index.js';

var _templateObject = taggedTemplateLiteral(['\n  background-color: ', ';\n  border-radius: ', ';\n  ', ';\n  line-height: 17px;\n  opacity: 0;\n  outline: none;\n  padding: 10px 15px;\n  position: absolute;\n  transition: opacity 300ms ease;\n  width: ', ';\n\n  ', '\n'], ['\n  background-color: ', ';\n  border-radius: ', ';\n  ', ';\n  line-height: 17px;\n  opacity: 0;\n  outline: none;\n  padding: 10px 15px;\n  position: absolute;\n  transition: opacity 300ms ease;\n  width: ', ';\n\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n  ', '\n  display: block;\n  ', '\n  position: relative;\n  overflow: hidden;\n\n  &:focus,\n  &:hover {\n    overflow: initial;\n\n    & > ', ' {\n      opacity: 1;\n    }\n  }\n\n  ', '\n'], ['\n  ', '\n  display: block;\n  ', '\n  position: relative;\n  overflow: hidden;\n\n  &:focus,\n  &:hover {\n    overflow: initial;\n\n    & > ', ' {\n      opacity: 1;\n    }\n  }\n\n  ', '\n']),
    _templateObject3 = taggedTemplateLiteral(['\n  background-color: transparent;\n  border: none;\n  border-radius: ', ';\n  ', ';\n  ', '\n  padding: 0;\n\n  > svg {\n    display: block;\n  }\n'], ['\n  background-color: transparent;\n  border: none;\n  border-radius: ', ';\n  ', ';\n  ', '\n  padding: 0;\n\n  > svg {\n    display: block;\n  }\n']);

var Tooltip = styled.div(_templateObject, function (_ref) {
  var secondary = _ref.secondary,
      backgroundColor = _ref.backgroundColor;
  return secondary ? theme.colors.GRAY_DARKER : backgroundColor;
}, theme.borders.RADIUS_1, function (_ref2) {
  var secondary = _ref2.secondary,
      fontColor = _ref2.fontColor;
  return fontStyle(secondary ? theme.colors.WHITE : fontColor, theme.fontSizes.SIZE_7, theme.fontWeights.SEMIBOLD);
}, function (_ref3) {
  var width = _ref3.width;
  return width;
}, function (_ref4) {
  var top = _ref4.top,
      right = _ref4.right,
      buttonSize = _ref4.buttonSize;

  var gutter = 10;
  var size = buttonSize + gutter + 'px';

  return '\n      ' + (top ? 'bottom' : 'top') + ': ' + size + ';\n      ' + (right ? 'left' : 'right') + ': 0;\n    ';
});

var Container = styled.div(_templateObject2, globalStyle(), function (_ref5) {
  var buttonSize = _ref5.buttonSize;
  return '\n    height: ' + buttonSize + 'px;\n    width: ' + buttonSize + 'px;\n  ';
}, Tooltip, function (_ref6) {
  var customStyles = _ref6.customStyles;
  return customStyles;
});

var Button = styled.div(_templateObject3, theme.borders.RADIUS_ROUND, function (_ref7) {
  var secondary = _ref7.secondary,
      fontColor = _ref7.fontColor;
  return fontStyle(secondary ? theme.colors.GRAY_DARKER : fontColor, theme.fontSizes.SIZE_7, theme.fontWeights.NORMAL);
}, function (_ref8) {
  var buttonSize = _ref8.buttonSize;
  return '\n    height: ' + buttonSize + 'px;\n    width: ' + buttonSize + 'px;\n  ';
});

var Tooltip$1 = function Tooltip$$1(_ref) {
  var id = _ref.id,
      className = _ref.className,
      top = _ref.top,
      right = _ref.right,
      secondary = _ref.secondary,
      children = _ref.children,
      backgroundColor = _ref.backgroundColor,
      fontColor = _ref.fontColor,
      width = _ref.width,
      buttonSize = _ref.buttonSize,
      customStyles = _ref.customStyles;
  return React.createElement(
    Container,
    {
      id: id,
      className: 'tooltip-4all ' + className,
      buttonSize: buttonSize,
      tabIndex: '0',
      customStyles: customStyles
    },
    React.createElement(
      Button,
      {
        backgroundColor: backgroundColor,
        fontColor: fontColor,
        secondary: secondary,
        buttonSize: buttonSize,
        className: 'tooltip-4all-button'
      },
      React.createElement(InfoIcon, {
        className: 'tooltip-4all-icon',
        color: secondary ? theme.colors.GRAY_DARKER : backgroundColor,
        width: buttonSize + 'px',
        height: buttonSize + 'px'
      })
    ),
    React.createElement(
      Tooltip,
      {
        backgroundColor: backgroundColor,
        fontColor: fontColor,
        top: top,
        right: right,
        secondary: secondary,
        width: width,
        buttonSize: buttonSize,
        className: 'tooltip-4all-text'
      },
      children
    )
  );
};

Tooltip$1.propTypes = {
  id: PropTypes.string,
  className: PropTypes.string,
  top: PropTypes.bool,
  right: PropTypes.bool,
  secondary: PropTypes.bool,
  children: PropTypes.any.isRequired,
  backgroundColor: PropTypes.string,
  fontColor: PropTypes.string,
  width: PropTypes.string,
  buttonSize: PropTypes.number,
  customStyles: PropTypes.object
};

Tooltip$1.defaultProps = {
  id: '',
  className: '',
  top: true,
  right: true,
  secondary: false,
  backgroundColor: theme.colors.MAIN_COLOR,
  fontColor: theme.colors.WHITE,
  width: '250px',
  buttonSize: 20,
  customStyles: {}
};

export default Tooltip$1;
//# sourceMappingURL=index.js.map
